# coding: utf-8

"""
    TKG Kubernetes API

    This API provides to vCD tenants the means to provision (create and update) Tanzu Kubernetes Grid clusters. This is complementary to the defined-entity APIs:    GET /cloudapi/1.0.0/entities/urn:vcloud:entity:vmware.tkgcluster:1.0.0:{id} which allows to retrieve the clusters created by the API presented here. This is why you will not find here a GET operation for the corresponding entity.   # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class TkgClusterSpecSettingsNetworkPods(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'cidr_blocks': 'list[str]'
    }

    attribute_map = {
        'cidr_blocks': 'cidrBlocks'
    }

    def __init__(self, cidr_blocks=None):  # noqa: E501
        """TkgClusterSpecSettingsNetworkPods - a model defined in Swagger"""  # noqa: E501

        self._cidr_blocks = None
        self.discriminator = None

        if cidr_blocks is not None:
            self.cidr_blocks = cidr_blocks

    @property
    def cidr_blocks(self):
        """Gets the cidr_blocks of this TkgClusterSpecSettingsNetworkPods.  # noqa: E501

        Specifies a range of IP addresses to use for Kubernetes pods.   # noqa: E501

        :return: The cidr_blocks of this TkgClusterSpecSettingsNetworkPods.  # noqa: E501
        :rtype: list[str]
        """
        return self._cidr_blocks

    @cidr_blocks.setter
    def cidr_blocks(self, cidr_blocks):
        """Sets the cidr_blocks of this TkgClusterSpecSettingsNetworkPods.

        Specifies a range of IP addresses to use for Kubernetes pods.   # noqa: E501

        :param cidr_blocks: The cidr_blocks of this TkgClusterSpecSettingsNetworkPods.  # noqa: E501
        :type: list[str]
        """

        self._cidr_blocks = cidr_blocks

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TkgClusterSpecSettingsNetworkPods):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
